<!DOCTYPE html>
<html
        lang="en"
        xmlns:th="http://www.thymeleaf.org"
        xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
        xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
        layout:decorate="~{layout3}"
>
<head>
    <meta charset="UTF-8" />
    <title>KPI Lecturer</title>
</head>
<body>

<main
        layout:fragment="main"
        class="container-xxl bd-gutter mt-3 my-md-4 bd-layout"
>
    <div th:include="sidebar/sidebar_masterdata::sidebar_masterdata" th:remove="tag">
        sidebar
    </div>

    <main class="bd-main-xxl">
        <div class="row">
            <div class="col-md-12">
                <div class="h4 pb-2 mb-4 text-dark border-bottom border-dark">
                    <i class="fa fa-check-circle text-secondary"></i> KPI Lecturer
                </div>
            </div>
        </div>

        <div class="row mb-3">
            <div class="col-md-12">
                <div class="shadow-sm rounded-3 p-4 bg-body small">
                    <div class="mb-2">
                        <span class="text-secondary text-lg fw-bold">KPI Lecturer List</span>
                    </div>
                    <span class="text-secondary">Class : </span>
                    <span class="text-secondary" th:text="${lecturerClass.getClasss() + ' ('+ lecturerClass.getDescription() + ')'}"></span>
<!--                    <br>-->
<!--                    <span class="text-secondary">Department : </span>-->
<!--                    <span class="text-secondary" th:text="${jobPosition.getDepartment().getDepartmentName()}"></span>-->
                </div>
                <input type="hidden" class="eroredit" th:value="${eroredit}"></input>
            </div>
        </div>

        <!-- Table & Buttons -->

        <div class="row">
            <div class="col-md-12">
                <div class="alert alert-success mb-3" role="alert" th:if="${berhasil != null}">
                    <i class="fa fa-check"></i> <span th:text="${berhasil}"></span>
                </div>
                <div class="card shadow-sm border-0 small">
                    <div class="card-body p-4 border-bottom">
                        <div class="d-flex justify-content-between">
                            <span class="fw-bold text-secondary">List key performance indicator</span>
                            <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#editKpiModal">
                                Add KPI
                            </button>
                        </div>
                    </div>
                    <div class="card-body p-0 pb-0">
                        <div class="table-responsive mb-0">
                            <table class="table table-striped table-hover mb-0">
                                <thead>
                                <tr>
                                    <th class="border-dark border-start-0 border-end-0 align-middle text-end pt-3 pb-3" style="width: 20px">#</th>
                                    <th class="border-dark border-start-0 border-end-0 align-middle pt-3 pb-3">Key</th>
                                    <th class="border-dark border-start-0 border-end-0 align-middle pt-3 pb-3">Indicator</th>
                                    <th class="border-dark border-start-0 border-end-0 align-middle pt-3 pb-3">Evaluation</th>
                                    <th class="border-dark border-start-0 border-end-0 align-middle pt-3 pb-3">Nominal</th>
                                    <th colspan="2" class="border-dark border-start-0 border-end-0 align-middle text-center pt-3 pb-3">Actions</th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr th:each="data, row : ${lecturerClassKpiList}">
                                    <td class="border-start-0 border-end-0 align-middle text-end" th:text="${row.index + 1}+'.'"></td>
                                    <td class="border-start-0 border-end-0 align-middle" th:text="${data.kpi}"></td>
                                    <td class="border-start-0 border-end-0 align-middle" th:text="${data.indikator}"></td>
                                    <td class="border-start-0 border-end-0 align-middle">
                                        <div class="badge text-bg-warning" th:if="${data.getPeriodeEvaluasi().toString().equals('BULANAN')}" th:text="${data.getPeriodeEvaluasi()}"></div>
                                        <div class="badge text-bg-primary" th:if="${data.getPeriodeEvaluasi().toString().equals('SEMESTERAN')}" th:text="${data.getPeriodeEvaluasi()}"></div>
                                        <div class="badge text-bg-success" th:if="${data.getPeriodeEvaluasi().toString().equals('TAHUNAN')}" th:text="${data.getPeriodeEvaluasi()}"></div>
                                    </td>
                                    <td class="border-start-0 border-end-0 align-middle" th:text="${'Rp. ' + #numbers.formatDecimal(data.nominal, 0, 'POINT', 0, 'COMMA')}"></td>
                                    <td class="border-start-0 border-end-0 align-middle" style="width: 10px;">
                                        <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal"
                                                data-bs-target="#editKpiModal" th:data-id="${data.id}" onclick="loadKpiData(this)">
                                            <i class="fa fa-edit"></i>
                                        </button>
                                    </td>
                                    <td class="border-start-0 border-end-0 align-middle" style="width: 10px;">
                                        <form method="post" th:action="@{/masterdata/kpi/setting/delete}">
                                            <input type="hidden" name="search" th:value="${search}">
                                            <input type="hidden" name="page" th:value="${page}">
                                            <input type="hidden" name="size" th:value="${size}">
                                            <input type="hidden" name="lecturerClass" th:value="${lecturerClass.getId()}">
                                            <input type="hidden" name="positionKpi" th:value="${data.getId()}">
                                            <button type="submit" class="btn btn-danger btn-sm"
                                                    onclick="return confirm('Are you sure want to delete this?')">
                                                <i class="fa fa-trash"></i>
                                            </button>
                                        </form>

                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                    <div class="card-footer text-end p-4 bg-body border-top-0">
                        <a class="btn btn-secondary btn-sm" th:href="@{/masterdata/kpi_lecturer(lecturerClass = ${lecturerClass.getId()},search = ${search}, page = ${page}, size = ${size})}">Back</a>
                    </div>
                </div>
            </div>
        </div>
        <!-- Edit KPI Modal -->
        <div class="modal fade" id="editKpiModal" tabindex="-1" aria-labelledby="editKpiModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-lg">
                <div class="modal-content">
                    <div class="modal-header bg-primary text-light">
                        <h5 class="modal-title" id="editKpiModalLabel"><i class="fa fa-edit text-secondary"></i> Form KPI</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <form method="post" th:object="${lecturerClassKpi}" th:action="@{/masterdata/kpi_lecturer/setting/save}" enctype="multipart/form-data">
                        <div class="modal-body">
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="EditKpiTextarea" class="form-label text-secondary">Key performance</label>
                                        <textarea class="form-control" id="EditKpiTextarea" name="kpi" th:field="*{kpi}" rows="3"></textarea>
                                        <div th:if="${#fields.hasErrors('kpi')}" class="error-message" th:errors="*{kpi}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="EditIndikator" class="form-label text-secondary">Indicator</label>
                                        <textarea class="form-control" id="EditIndikator" name="indikator" th:field="*{indikator}" rows="3"></textarea>
                                        <div th:if="${#fields.hasErrors('indikator')}" class="error-message" th:errors="*{indikator}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="EditPeriodeEvaluasi" class="form-label text-secondary">Period evaluation</label>
                                        <select class="form-select" id="EditPeriodeEvaluasi" aria-label="Default select example" th:field="*{periodeEvaluasi}">
                                            <option th:each="data : ${periodeEvaluasiKpi}"
                                                    th:text="${data}"
                                                    th:value="${data}">sdasd</option>
                                        </select>
                                        <div th:if="${#fields.hasErrors('periodeEvaluasi')}" class="error-message" th:errors="*{periodeEvaluasi}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="editNominal" class="form-label text-secondary">Nominal Max</label>
                                        <input type="text" class="form-control" id="editNominal" name="nominalString" th:field="*{nominalString}" rows="2">
                                        <div th:if="${#fields.hasErrors('nominalString')}" class="error-message" th:errors="*{nominalString}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="editSyaratAa" class="form-label text-secondary">Syarat grade (A)</label>
                                        <textarea class="form-control" id="editSyaratAa" name="syaratAa" th:field="*{syaratAa}" rows="2"></textarea>
                                        <div th:if="${#fields.hasErrors('syaratAa')}" class="error-message" th:errors="*{syaratAa}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="editBobotA" class="form-label text-secondary">Bobot %</label>
                                        <input type="number" class="form-control" id="editBobotA" name="bobotA" th:field="*{bobotA}" rows="2">
                                        <div th:if="${#fields.hasErrors('bobotA')}" class="error-message" th:errors="*{bobotA}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="editSyaratBb" class="form-label text-secondary">Syarat grade (B)</label>
                                        <textarea class="form-control" id="editSyaratBb" name="syaratBb" th:field="*{syaratBb}" rows="2"></textarea>
                                        <div th:if="${#fields.hasErrors('syaratBb')}" class="error-message" th:errors="*{syaratBb}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="editBobotB" class="form-label text-secondary">Bobot %</label>
                                        <input type="number" class="form-control" id="editBobotB" name="bobotB" th:field="*{bobotB}" rows="2">
                                        <div th:if="${#fields.hasErrors('bobotB')}" class="error-message" th:errors="*{bobotB}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="editSyaratCc" class="form-label text-secondary">Syarat grade (C)</label>
                                        <textarea class="form-control" id="editSyaratCc" name="syaratCc" th:field="*{syaratCc}" rows="2"></textarea>
                                        <div th:if="${#fields.hasErrors('syaratCc')}" class="error-message" th:errors="*{syaratCc}" style="color: red;"></div>
                                    </div>
                                    <input type="hidden" name="search" th:value="${search}">
                                    <input class="form-control" type="hidden" name="id" id="idkpi" th:field="*{id}">
                                    <input type="hidden" name="page" th:value="${page}">
                                    <input type="hidden" name="size" th:value="${size}">
                                    <input type="hidden" name="lecturerClass" th:value="${lecturerClass.getId()}">
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="editBobotC" class="form-label text-secondary">Bobot %</label>
                                        <input type="number" class="form-control" id="editBobotC" name="bobotC" th:field="*{bobotC}" rows="2">
                                        <div th:if="${#fields.hasErrors('bobotC')}" class="error-message" th:errors="*{bobotC}" style="color: red;"></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer p-3">
                            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
                            <button type="submit" class="btn btn-primary">Save</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </main>
</main>

</body>
</html>
<script>
    const nominalInput = document.getElementById("editNominal");

    nominalInput.addEventListener("input", function (e) {
        let value = e.target.value.replace(/\D/g, ""); // Hanya angka
        value = new Intl.NumberFormat("id-ID").format(value); // Format ke "id-ID" (Indonesia)
        e.target.value = value;
    });
</script>
<script>
    $(document).ready(function() {
        var hasErrors = $('.error-message').length > 0; // Memeriksa jika ada elemen dengan kelas error-message
        var eror = $('.eroredit').length > 0;
        console.log("Has Errors:", hasErrors); // Menampilkan apakah ada error
        if (hasErrors) {
            console.log("Showing modal"); // Menampilkan pesan di console
            if(eror){
                $('#editKpiModal').modal('show');
            }else{
                $('#addKpiModal').modal('show');
            }
        }
    });
</script>
<script>

    // Load KPI data ke modal saat ingin mengedit
    function loadKpiData(button) {
        const id = $(button).data('id');
        $.ajax({
            url: '/masterdata/kpi_lecturer/setting/data/' + id,
            method: 'GET',
            success: function(response) {
                // Mengisi data ke dalam textarea dan input yang sesuai
                $('#editKpiModal #EditKpiTextarea').val(response.kpi);
                $('#editKpiModal #EditIndikator').val(response.indikator);
                $('#editKpiModal #EditPeriodeEvaluasi').val(response.periodeEvaluasi);
                $('#editKpiModal #editSyaratAa').val(response.syaratAa);
                $('#editKpiModal #editSyaratBb').val(response.syaratBb);
                $('#editKpiModal #editSyaratCc').val(response.syaratCc);
                $('#editKpiModal #editNominal').val(response.nominalString);
                $('#editKpiModal #editBobotA').val(response.bobotA);
                $('#editKpiModal #editBobotB').val(response.bobotB);
                $('#editKpiModal #editBobotC').val(response.bobotC);
                $('#editKpiModal #idkpi').val(response.id);
                $('#editKpiModal').modal('show');  // Menampilkan modal setelah data diambil
            },
            error: function(error) {
                console.error("Error fetching KPI data:", error);
            }
        });
    }

    $('#addKpiModal, #editKpiModal').on('hidden.bs.modal', function() {
        // $(this).find('textarea, input, select').val(''); // Clear all textareas, inputs, and selects
        $(this).find('.form-control').val('');
        $(this).find('.form-select').val('');
        $('.error-message').empty();
    });


</script>

